
//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 01: Code Optimization
//
//  Description: Optimization effects
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 9.3
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ex1.c -o ex1
Executing:	time ./ex1

sum = 400000034998780787062429554585290932224.000000

real    0m1.318s
user    0m1.318s
sys     0m0.000s

*******************************************************
Compiling:      gcc ex1.c -o ex1 -O3 -funroll-loops -lm
sum = 400000034998780787062429554585290932224.000000

real    0m0.223s
user    0m0.223s
sys     0m0.000s

*/



// ******************************************************************
#include <stdio.h>

#define N 100000000

// ******************************************************************
double powern (double d, unsigned n)
{
  double x = 1.0;    unsigned int j;

  for (j = 1; j <= n; j++)
    x *= d;

  return x;
}

// ******************************************************************
void pp()
{
  double sum = 0.0;  unsigned int i;

for ( int i = 1 ; i < 10 ; i++ )
	sum += powern( i, 2 ) ;

}



// ******************************************************************
int main (void)
{
  double sum = 0.0;  unsigned int i;

  for (i = 1; i <= N ; i++)
      sum += powern(i,i%5);

  for (i = 1; i <= 100 ; i++)
	pp() ;

  printf ("sum = %lf\n", sum);
  return 0;
}

// ******************************************************************

